module Page.Landing exposing
    ( Model
    , Msg
    , view
    , init
    , update
    , subscriptions
    )
import Element exposing (Element)
import Websockets
import Ports
import Json.Decode as Decode

type alias Model = {
    time : String
    }
type alias Landing = {
    time : String
    }
type Msg
    = ToFrontend Landing
    | Time String
    | NoOp

init : () -> Model
init flags = {
    time = "time not yet set"
    }

decodeMessage : String -> String
decodeMessage message =
    let
        decodedMessage = Decode.decodeString (Decode.field "time" Decode.string) message
    in
        case decodedMessage of
            Ok decoded -> decoded
            Err err -> "failed to decode" ++ message

decodeMessageOld : String -> String
decodeMessageOld message =
    let
        decodedMessage = Decode.decodeString (Decode.field "time" Decode.string) message
    in
        case decodedMessage of
            Ok decoded -> decoded
            Err err -> "failed to decode" ++ message

subscriptions : Model -> Sub Msg
subscriptions model =
    Ports.socketOnEvent
        (Websockets.EventHandlers
            (\_ -> NoOp)
            (\_ -> NoOp)
            (\_ -> NoOp)
            (\message -> (message.data |> decodeMessageOld |> Time))
            (\_ -> NoOp)
        )

update : Msg -> Model -> (Model, Cmd Msg)
update msg model =
    case msg of
        Time time -> ( {model | time = time}, Cmd.none )
        _ -> (model, Cmd.none)

view : Model -> Element Msg
view model =
    Element.column []
        [ Element.text "Landing",
          Element.text <| "Time is : " ++ model.time
        ]
